diff -ruN vdr-1.5.6/menu.c vdr-1.5.7/menu.c
--- vdr-1.5.6/menu.c	2007-06-23 11:27:13.000000000 +0200
+++ vdr-1.5.7/menu.c	2007-08-12 12:44:35.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.c 1.456 2007/06/23 09:27:13 kls Exp $
+ * $Id: menu.c 1.459 2007/08/12 10:44:35 kls Exp $
  */
 
 #include "menu.h"
@@ -630,7 +630,7 @@
     case kRight|k_Repeat:
     case kRight:
                   DisplayMenu()->Scroll(NORMALKEY(Key) == kUp || NORMALKEY(Key) == kLeft, NORMALKEY(Key) == kLeft || NORMALKEY(Key) == kRight);
-                  cStatus::MsgOsdTextItem(NULL, NORMALKEY(Key) == kUp);
+                  cStatus::MsgOsdTextItem(NULL, NORMALKEY(Key) == kUp || NORMALKEY(Key) == kLeft);
                   return osContinue;
     default: break;
     }
@@ -980,7 +980,7 @@
     case kRight|k_Repeat:
     case kRight:
                   DisplayMenu()->Scroll(NORMALKEY(Key) == kUp || NORMALKEY(Key) == kLeft, NORMALKEY(Key) == kLeft || NORMALKEY(Key) == kRight);
-                  cStatus::MsgOsdTextItem(NULL, NORMALKEY(Key) == kUp);
+                  cStatus::MsgOsdTextItem(NULL, NORMALKEY(Key) == kUp || NORMALKEY(Key) == kLeft);
                   return osContinue;
     default: break;
     }
@@ -1809,7 +1809,7 @@
     case kRight|k_Repeat:
     case kRight:
                   DisplayMenu()->Scroll(NORMALKEY(Key) == kUp || NORMALKEY(Key) == kLeft, NORMALKEY(Key) == kLeft || NORMALKEY(Key) == kRight);
-                  cStatus::MsgOsdTextItem(NULL, NORMALKEY(Key) == kUp);
+                  cStatus::MsgOsdTextItem(NULL, NORMALKEY(Key) == kUp || NORMALKEY(Key) == kLeft);
                   return osContinue;
     default: break;
     }
@@ -2153,6 +2153,7 @@
 class cMenuSetupOSD : public cMenuSetupBase {
 private:
   const char *useSmallFontTexts[3];
+  int osdLanguageIndex;
   int numSkins;
   int originalSkinIndex;
   int skinIndex;
@@ -2171,6 +2172,7 @@
 
 cMenuSetupOSD::cMenuSetupOSD(void)
 {
+  osdLanguageIndex = I18nCurrentLanguage();
   numSkins = Skins.Count();
   skinIndex = originalSkinIndex = Skins.Current()->Index();
   skinDescriptions = new const char*[numSkins];
@@ -2203,7 +2205,7 @@
   useSmallFontTexts[2] = tr("always");
   Clear();
   SetSection(tr("OSD"));
-  Add(new cMenuEditStraItem(tr("Setup.OSD$Language"),               &data.OSDLanguage, I18nNumLanguages, I18nLanguages()));
+  Add(new cMenuEditStraItem(tr("Setup.OSD$Language"),               &osdLanguageIndex, I18nLanguages()->Size(), &I18nLanguages()->At(0)));
   Add(new cMenuEditStraItem(tr("Setup.OSD$Skin"),                   &skinIndex, numSkins, skinDescriptions));
   if (themes.NumThemes())
   Add(new cMenuEditStraItem(tr("Setup.OSD$Theme"),                  &themeIndex, themes.NumThemes(), themes.Descriptions()));
@@ -2237,6 +2239,7 @@
   bool ModifiedApperance = false;
 
   if (Key == kOk) {
+     I18nSetLocale(data.OSDLanguage);
      if (skinIndex != originalSkinIndex) {
         cSkin *Skin = Skins.Get(skinIndex);
         if (Skin) {
@@ -2273,16 +2276,17 @@
         }
      }
 
-  int osdLanguage = data.OSDLanguage;
   int oldSkinIndex = skinIndex;
+  int oldOsdLanguageIndex = osdLanguageIndex;
   eOSState state = cMenuSetupBase::ProcessKey(Key);
 
   if (ModifiedApperance)
      SetDisplayMenu();
 
-  if (data.OSDLanguage != osdLanguage || skinIndex != oldSkinIndex) {
-     int OriginalOSDLanguage = Setup.OSDLanguage;
-     Setup.OSDLanguage = data.OSDLanguage;
+  if (osdLanguageIndex != oldOsdLanguageIndex || skinIndex != oldSkinIndex) {
+     strn0cpy(data.OSDLanguage, I18nLocale(osdLanguageIndex), sizeof(data.OSDLanguage));
+     int OriginalOSDLanguage = I18nCurrentLanguage();
+     I18nSetLanguage(osdLanguageIndex);
 
      cSkin *Skin = Skins.Get(skinIndex);
      if (Skin) {
@@ -2294,7 +2298,7 @@
         }
 
      Set();
-     Setup.OSDLanguage = OriginalOSDLanguage;
+     I18nSetLanguage(OriginalOSDLanguage);
      }
   return state;
 }
@@ -2313,7 +2317,7 @@
 
 cMenuSetupEPG::cMenuSetupEPG(void)
 {
-  for (numLanguages = 0; numLanguages < I18nNumLanguages && data.EPGLanguages[numLanguages] >= 0; numLanguages++)
+  for (numLanguages = 0; numLanguages < I18nLanguages()->Size() && data.EPGLanguages[numLanguages] >= 0; numLanguages++)
       ;
   originalNumLanguages = numLanguages;
   SetSection(tr("EPG"));
@@ -2333,9 +2337,11 @@
   Add(new cMenuEditBoolItem(tr("Setup.EPG$Set system time"),           &data.SetSystemTime));
   if (data.SetSystemTime)
      Add(new cMenuEditTranItem(tr("Setup.EPG$Use time from transponder"), &data.TimeTransponder, &data.TimeSource));
-  Add(new cMenuEditIntItem( tr("Setup.EPG$Preferred languages"),       &numLanguages, 0, I18nNumLanguages));
+  // TRANSLATORS: note the plural!
+  Add(new cMenuEditIntItem( tr("Setup.EPG$Preferred languages"),       &numLanguages, 0, I18nLanguages()->Size()));
   for (int i = 0; i < numLanguages; i++)
-     Add(new cMenuEditStraItem(tr("Setup.EPG$Preferred language"),     &data.EPGLanguages[i], I18nNumLanguages, I18nLanguages()));
+      // TRANSLATORS: note the singular!
+      Add(new cMenuEditStraItem(tr("Setup.EPG$Preferred language"),    &data.EPGLanguages[i], I18nLanguages()->Size(), &I18nLanguages()->At(0)));
 
   SetCurrent(Get(current));
   Display();
@@ -2365,7 +2371,7 @@
      if (numLanguages != oldnumLanguages || data.SetSystemTime != oldSetSystemTime) {
         for (int i = oldnumLanguages; i < numLanguages; i++) {
             data.EPGLanguages[i] = 0;
-            for (int l = 0; l < I18nNumLanguages; l++) {
+            for (int l = 0; l < I18nLanguages()->Size(); l++) {
                 int k;
                 for (k = 0; k < oldnumLanguages; k++) {
                     if (data.EPGLanguages[k] == l)
@@ -2404,7 +2410,7 @@
 
 cMenuSetupDVB::cMenuSetupDVB(void)
 {
-  for (numAudioLanguages = 0; numAudioLanguages < I18nNumLanguages && data.AudioLanguages[numAudioLanguages] >= 0; numAudioLanguages++)
+  for (numAudioLanguages = 0; numAudioLanguages < I18nLanguages()->Size() && data.AudioLanguages[numAudioLanguages] >= 0; numAudioLanguages++)
       ;
   originalNumAudioLanguages = numAudioLanguages;
   videoDisplayFormatTexts[0] = tr("pan&scan");
@@ -2433,9 +2439,9 @@
      Add(new cMenuEditStraItem(tr("Setup.DVB$Video display format"), &data.VideoDisplayFormat, 3, videoDisplayFormatTexts));
   Add(new cMenuEditBoolItem(tr("Setup.DVB$Use Dolby Digital"),     &data.UseDolbyDigital));
   Add(new cMenuEditStraItem(tr("Setup.DVB$Update channels"),       &data.UpdateChannels, 6, updateChannelsTexts));
-  Add(new cMenuEditIntItem( tr("Setup.DVB$Audio languages"),       &numAudioLanguages, 0, I18nNumLanguages));
+  Add(new cMenuEditIntItem( tr("Setup.DVB$Audio languages"),       &numAudioLanguages, 0, I18nLanguages()->Size()));
   for (int i = 0; i < numAudioLanguages; i++)
-      Add(new cMenuEditStraItem(tr("Setup.DVB$Audio language"),    &data.AudioLanguages[i], I18nNumLanguages, I18nLanguages()));
+      Add(new cMenuEditStraItem(tr("Setup.DVB$Audio language"),    &data.AudioLanguages[i], I18nLanguages()->Size(), &I18nLanguages()->At(0)));
 
   SetCurrent(Get(current));
   Display();
@@ -2455,7 +2461,7 @@
      if (numAudioLanguages != oldnumAudioLanguages) {
         for (int i = oldnumAudioLanguages; i < numAudioLanguages; i++) {
             data.AudioLanguages[i] = 0;
-            for (int l = 0; l < I18nNumLanguages; l++) {
+            for (int l = 0; l < I18nLanguages()->Size(); l++) {
                 int k;
                 for (k = 0; k < oldnumAudioLanguages; k++) {
                     if (data.AudioLanguages[k] == l)
@@ -2826,7 +2832,7 @@
 
 eOSState cMenuSetup::ProcessKey(eKeys Key)
 {
-  int osdLanguage = Setup.OSDLanguage;
+  int osdLanguage = I18nCurrentLanguage();
   eOSState state = cOsdMenu::ProcessKey(Key);
 
   switch (state) {
@@ -2842,7 +2848,7 @@
     case osUser10: return Restart();
     default: ;
     }
-  if (Setup.OSDLanguage != osdLanguage) {
+  if (I18nCurrentLanguage() != osdLanguage) {
      Set();
      if (!HasSubMenu())
         Display();
@@ -2868,7 +2874,8 @@
 
 // --- cMenuMain -------------------------------------------------------------
 
-#define STOP_RECORDING tr(" Stop recording ")
+// TRANSLATORS: note the leading and trailing blanks!
+#define STOP_RECORDING trNOOP(" Stop recording ")
 
 cOsdObject *cMenuMain::pluginOsdObject = NULL;
 
@@ -2967,6 +2974,7 @@
      replaying = NewReplaying;
      // Replay control:
      if (replaying && !stopReplayItem)
+        // TRANSLATORS: note the leading blank!
         Add(stopReplayItem = new cOsdItem(tr(" Stop replaying"), osStopReplay));
      else if (stopReplayItem && !replaying) {
         Del(stopReplayItem->Index());
@@ -2980,6 +2988,7 @@
   // Editing control:
   bool CutterActive = cCutter::Active();
   if (CutterActive && !cancelEditingItem) {
+     // TRANSLATORS: note the leading blank!
      Add(cancelEditingItem = new cOsdItem(tr(" Cancel editing"), osCancelEdit));
      result = true;
      }
@@ -2999,7 +3008,7 @@
      const char *s = NULL;
      while ((s = cRecordControls::GetInstantId(s)) != NULL) {
            char *buffer = NULL;
-           asprintf(&buffer, "%s%s", STOP_RECORDING, s);
+           asprintf(&buffer, "%s%s", tr(STOP_RECORDING), s);
            cOsdItem *item = new cOsdItem(osStopRecord);
            item->SetText(buffer, false);
            Add(item);
@@ -3015,7 +3024,7 @@
 eOSState cMenuMain::ProcessKey(eKeys Key)
 {
   bool HadSubMenu = HasSubMenu();
-  int osdLanguage = Setup.OSDLanguage;
+  int osdLanguage = I18nCurrentLanguage();
   eOSState state = cOsdMenu::ProcessKey(Key);
   HadSubMenu |= HasSubMenu();
 
@@ -3029,7 +3038,7 @@
     case osStopRecord: if (Interface->Confirm(tr("Stop recording?"))) {
                           cOsdItem *item = Get(Current());
                           if (item) {
-                             cRecordControls::Stop(item->Text() + strlen(STOP_RECORDING));
+                             cRecordControls::Stop(item->Text() + strlen(tr(STOP_RECORDING)));
                              return osEnd;
                              }
                           }
@@ -3080,7 +3089,7 @@
   if (!HasSubMenu() && Update(HadSubMenu))
      Display();
   if (Key != kNone) {
-     if (Setup.OSDLanguage != osdLanguage) {
+     if (I18nCurrentLanguage() != osdLanguage) {
         Set();
         if (!HasSubMenu())
            Display();
@@ -3482,6 +3491,7 @@
          numTracks++;
          }
       }
+  descriptions[numTracks] = 0;
   timeout.Set(TRACKTIMEOUT);
   displayTracks = Skins.Current()->DisplayTracks(tr("Button$Audio"), numTracks, descriptions);
   Show();
@@ -4026,6 +4036,7 @@
 void cReplayControl::TimeSearchDisplay(void)
 {
   char buf[64];
+  // TRANSLATORS: note the trailing blank!
   strcpy(buf, tr("Jump: "));
   int len = strlen(buf);
   char h10 = '0' + (timeSearchTime >> 24);
diff -ruN vdr-1.5.6/menu.h vdr-1.5.7/menu.h
--- vdr-1.5.6/menu.h	2007-01-05 11:40:54.000000000 +0100
+++ vdr-1.5.7/menu.h	2007-08-12 12:35:42.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.h 1.87 2007/01/05 10:40:54 kls Exp $
+ * $Id: menu.h 1.88 2007/08/12 10:35:42 kls Exp $
  */
 
 #ifndef __MENU_H
@@ -115,7 +115,7 @@
   cSkinDisplayTracks *displayTracks;
   cTimeMs timeout;
   eTrackType types[ttMaxTrackTypes];
-  char *descriptions[ttMaxTrackTypes];
+  char *descriptions[ttMaxTrackTypes + 1]; // list is NULL terminated
   int numTracks, track, audioChannel;
   static cDisplayTracks *currentDisplayTracks;
   virtual void Show(void);
diff -ruN vdr-1.5.6/menuitems.c vdr-1.5.7/menuitems.c
--- vdr-1.5.6/menuitems.c	2007-06-08 17:16:38.000000000 +0200
+++ vdr-1.5.7/menuitems.c	2007-08-04 11:12:18.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menuitems.c 1.49 2007/06/08 15:16:38 kls Exp $
+ * $Id: menuitems.c 1.50 2007/08/04 09:12:18 kls Exp $
  */
 
 #include "menuitems.h"
@@ -18,7 +18,7 @@
 
 #define AUTO_ADVANCE_TIMEOUT  1500 // ms before auto advance when entering characters via numeric keys
 
-const char *FileNameChars = " abcdefghijklmnopqrstuvwxyz0123456789-.#~,/_@";
+const char *FileNameChars = trNOOP(" abcdefghijklmnopqrstuvwxyz0123456789-.#~,/_@");
 
 // --- cMenuEditItem ---------------------------------------------------------
 
@@ -316,7 +316,7 @@
 void cMenuEditStrItem::SetHelpKeys(void)
 {
   if (InEditMode())
-     cSkinDisplay::Current()->SetButtons(tr("Button$ABC/abc"), tr(insert ? "Button$Overwrite" : "Button$Insert"), tr("Button$Delete"));
+     cSkinDisplay::Current()->SetButtons(tr("Button$ABC/abc"), insert ? tr("Button$Overwrite") : tr("Button$Insert"), tr("Button$Delete"));
   else
      cSkinDisplay::Current()->SetButtons(NULL);
 }
diff -ruN vdr-1.5.6/newplugin vdr-1.5.7/newplugin
--- vdr-1.5.6/newplugin	2007-04-28 16:46:39.000000000 +0200
+++ vdr-1.5.7/newplugin	2007-08-12 13:04:39.000000000 +0200
@@ -12,7 +12,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: newplugin 1.32 2007/04/28 14:46:39 kls Exp $
+# $Id: newplugin 1.34 2007/08/12 11:04:39 kls Exp $
 
 $PLUGIN_NAME = $ARGV[0] || die "Usage: newplugin <name>\n";
 
@@ -35,7 +35,11 @@
 
 Latest version available at: URL
 
-See the file COPYING for license information.
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+See the file COPYING for more information.
 
 Description:
 };
@@ -109,7 +113,7 @@
 %.o: %.c
 	\$(CXX) \$(CXXFLAGS) -c \$(DEFINES) \$(INCLUDES) \$<
 
-# Dependencies:
+### Dependencies:
 
 MAKEDEP = \$(CXX) -MM -MG
 DEPFILE = .dependencies
@@ -118,9 +122,34 @@
 
 -include \$(DEPFILE)
 
+### Internationalization (I18N):
+
+PODIR     = po
+LOCALEDIR = \$(VDRDIR)/locale
+I18Npo    = \$(wildcard \$(PODIR)/*.po)
+I18Nmo    = \$(addsuffix .mo, \$(foreach file, \$(I18Npo), \$(basename \$(file))))
+I18Ndirs  = \$(notdir \$(foreach file, \$(I18Npo), \$(basename \$(file))))
+I18Npot   = \$(PODIR)/\$(PLUGIN).pot
+
+%.mo: %.po
+	msgfmt -c -o \$\@ \$<
+
+\$(I18Npot): \$(wildcard *.c)
+	xgettext -C -cTRANSLATORS --no-wrap -F -k -ktr -ktrNOOP --msgid-bugs-address='<see README>' -o \$\@ \$(wildcard *.c)
+
+\$(I18Npo): \$(I18Npot)
+	msgmerge -U --no-wrap -F --backup=none -q \$\@ \$<
+
+i18n: \$(I18Nmo)
+	\@mkdir -p \$(LOCALEDIR)
+	for i in \$(I18Ndirs); do\\
+	    mkdir -p \$(LOCALEDIR)/\$\$i/LC_MESSAGES;\\
+	    cp \$(PODIR)/\$\$i.mo \$(LOCALEDIR)/\$\$i/LC_MESSAGES/\$(PLUGIN).mo;\\
+	    done
+
 ### Targets:
 
-all: libvdr-\$(PLUGIN).so
+all: libvdr-\$(PLUGIN).so i18n
 
 libvdr-\$(PLUGIN).so: \$(OBJS)
 	\$(CXX) \$(CXXFLAGS) -shared \$(OBJS) -o \$\@
@@ -135,7 +164,7 @@
 	\@echo Distribution package created as \$(PACKAGE).tgz
 
 clean:
-	\@-rm -f \$(OBJS) \$(DEPFILE) *.so *.tgz core* *~
+	\@-rm -f \$(OBJS) \$(DEPFILE) *.so *.tgz core* *~ \$(PODIR)/*.mo \$(PODIR)/*.pot
 };
 
 $MAIN = qq
diff -ruN vdr-1.5.6/osd.c vdr-1.5.7/osd.c
--- vdr-1.5.6/osd.c	2007-07-20 16:51:36.000000000 +0200
+++ vdr-1.5.7/osd.c	2007-08-12 13:33:17.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osd.c 1.71 2007/07/20 14:51:36 kls Exp $
+ * $Id: osd.c 1.72 2007/08/12 11:33:17 kls Exp $
  */
 
 #include "osd.h"
@@ -321,6 +321,8 @@
 
 bool cBitmap::SetXpm(const char *const Xpm[], bool IgnoreNone)
 {
+  if (!Xpm)
+     return false;
   const char *const *p = Xpm;
   int w, h, n, c;
   if (4 != sscanf(*p, "%d %d %d %d", &w, &h, &n, &c)) {
diff -ruN vdr-1.5.6/plugin.c vdr-1.5.7/plugin.c
--- vdr-1.5.6/plugin.c	2007-02-24 14:44:23.000000000 +0100
+++ vdr-1.5.7/plugin.c	2007-08-05 14:48:50.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: plugin.c 1.25 2007/02/24 13:44:23 kls Exp $
+ * $Id: plugin.c 1.26 2007/08/05 12:48:50 kls Exp $
  */
 
 #include "plugin.h"
@@ -35,12 +35,12 @@
 
 cPlugin::~cPlugin()
 {
-  I18nRegister(NULL, Name());
 }
 
 void cPlugin::SetName(const char *s)
 {
   name = s;
+  I18nRegister(name);
 }
 
 const char *cPlugin::CommandLineHelp(void)
@@ -130,9 +130,9 @@
   return NULL;
 }
 
-void cPlugin::RegisterI18n(const tI18nPhrase * const Phrases)
+void cPlugin::RegisterI18n(const void *)
 {
-  I18nRegister(Phrases, Name());
+  dsyslog("plugin '%s' called obsolete function RegisterI18n()", Name());
 }
 
 void cPlugin::SetConfigDirectory(const char *Dir)
@@ -338,10 +338,7 @@
   for (cDll *dll = dlls.First(); dll; dll = dlls.Next(dll)) {
       cPlugin *p = dll->Plugin();
       if (p) {
-         int Language = Setup.OSDLanguage;
-         Setup.OSDLanguage = 0; // the i18n texts are only available _after_ Start()
          isyslog("initializing plugin: %s (%s): %s", p->Name(), p->Version(), p->Description());
-         Setup.OSDLanguage = Language;
          if (!p->Initialize())
             return false;
          }
@@ -354,10 +351,7 @@
   for (cDll *dll = dlls.First(); dll; dll = dlls.Next(dll)) {
       cPlugin *p = dll->Plugin();
       if (p) {
-         int Language = Setup.OSDLanguage;
-         Setup.OSDLanguage = 0; // the i18n texts are only available _after_ Start()
          isyslog("starting plugin: %s", p->Name());
-         Setup.OSDLanguage = Language;
          if (!p->Start())
             return false;
          p->started = true;
diff -ruN vdr-1.5.6/plugin.h vdr-1.5.7/plugin.h
--- vdr-1.5.6/plugin.h	2007-02-24 14:45:28.000000000 +0100
+++ vdr-1.5.7/plugin.h	2007-08-04 11:56:26.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: plugin.h 1.14 2007/02/24 13:45:28 kls Exp $
+ * $Id: plugin.h 1.15 2007/08/04 09:56:26 kls Exp $
  */
 
 #ifndef __PLUGIN_H
@@ -51,7 +51,7 @@
   void SetupStore(const char *Name, const char *Value = NULL);
   void SetupStore(const char *Name, int Value);
 
-  void RegisterI18n(const tI18nPhrase * const Phrases);
+  void RegisterI18n(const void *); ///< This function is obsolete and may be removed in future versions of VDR!
 
   virtual bool Service(const char *Id, void *Data = NULL);
   virtual const char **SVDRPHelpPages(void);
diff -ruN vdr-1.5.6/receiver.c vdr-1.5.7/receiver.c
--- vdr-1.5.6/receiver.c	2007-01-05 11:42:29.000000000 +0100
+++ vdr-1.5.7/receiver.c	2007-08-12 13:52:59.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: receiver.c 1.6 2007/01/05 10:42:29 kls Exp $
+ * $Id: receiver.c 1.7 2007/08/12 11:52:59 kls Exp $
  */
 
 #include "receiver.h"
@@ -38,7 +38,12 @@
 
 cReceiver::~cReceiver()
 {
-  Detach();
+  if (device) {
+     const char *msg = "ERROR: cReceiver has not been detached yet! This is a design fault and VDR will segfault now!";
+     esyslog(msg);
+     fprintf(stderr, "%s\n", msg);
+     *(char *)0 = 0; // cause a segfault
+     }
 }
 
 bool cReceiver::WantsPid(int Pid)
diff -ruN vdr-1.5.6/skinclassic.c vdr-1.5.7/skinclassic.c
--- vdr-1.5.6/skinclassic.c	2007-06-17 15:53:09.000000000 +0200
+++ vdr-1.5.7/skinclassic.c	2007-07-29 14:35:03.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skinclassic.c 1.17 2007/06/17 13:53:09 kls Exp $
+ * $Id: skinclassic.c 1.18 2007/07/29 12:35:03 kls Exp $
  */
 
 #include "skinclassic.h"
@@ -549,6 +549,7 @@
      osd->DrawText(0, 0, tr("Key$Mute"), Theme.Color(clrVolumePrompt), Theme.Color(clrBackground), font);
      }
   else {
+     // TRANSLATORS: note the trailing blank!
      const char *Prompt = tr("Volume ");
      int l = font->Width(Prompt);
      int p = (osd->Width() - l) * Current / Total;
diff -ruN vdr-1.5.6/status.h vdr-1.5.7/status.h
--- vdr-1.5.6/status.h	2005-12-31 16:15:25.000000000 +0100
+++ vdr-1.5.7/status.h	2007-08-12 12:34:40.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: status.h 1.9 2005/12/31 15:15:25 kls Exp $
+ * $Id: status.h 1.10 2007/08/12 10:34:40 kls Exp $
  */
 
 #ifndef __STATUS_H
@@ -40,7 +40,7 @@
                // absolutely or relative to the current volume.
   virtual void SetAudioTrack(int Index, const char * const *Tracks) {}
                // The audio track has been set to the one given by Index, which
-               // points into the Tracks array of strings.
+               // points into the Tracks array of strings. Tracks is NULL terminated.
   virtual void SetAudioChannel(int AudioChannel) {}
                // The audio channel has been set to the given value.
                // 0=stereo, 1=left, 2=right, -1=no information available.
diff -ruN vdr-1.5.6/themes.c vdr-1.5.7/themes.c
--- vdr-1.5.6/themes.c	2005-11-04 15:19:54.000000000 +0100
+++ vdr-1.5.7/themes.c	2007-08-05 16:11:35.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: themes.c 1.6 2005/11/04 14:19:54 kls Exp $
+ * $Id: themes.c 1.7 2007/08/05 14:11:35 kls Exp $
  */
 
 #include "themes.h"
@@ -18,7 +18,6 @@
 cTheme::cTheme(void)
 {
   name = strdup("default");
-  memset(descriptions, 0, sizeof(descriptions));
   memset(colorNames, 0, sizeof(colorNames));
   memset(colorValues, 0, sizeof(colorValues));
   descriptions[0] = strdup("Default");
@@ -27,8 +26,6 @@
 cTheme::~cTheme()
 {
   free(name);
-  for (int i = 0; i < I18nNumLanguages; i++)
-      free(descriptions[i]);
   for (int i = 0; i < MaxThemeColors; i++)
       free(colorNames[i]);
 }
@@ -77,7 +74,7 @@
 
 const char *cTheme::Description(void)
 {
-  char *s = descriptions[Setup.OSDLanguage];
+  char *s = descriptions[I18nCurrentLanguage()];
   if (!s)
      s = descriptions[0];
   return s ? s : name;
@@ -167,7 +164,7 @@
   bool result = true;
   cSafeFile f(FileName);
   if (f.Open()) {
-     for (int i = 0; i < I18nNumLanguages; i++) {
+     for (int i = 0; i < I18nLanguages()->Size(); i++) {
          if (descriptions[i])
             fprintf(f, "Description%s%.*s = %s\n", i ? "." : "", 3, i ? I18nLanguageCode(i) : "", descriptions[i]);
          }
diff -ruN vdr-1.5.6/themes.h vdr-1.5.7/themes.h
--- vdr-1.5.6/themes.h	2004-05-15 16:22:16.000000000 +0200
+++ vdr-1.5.7/themes.h	2007-08-05 16:10:22.000000000 +0200
@@ -4,13 +4,14 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: themes.h 1.1 2004/05/15 14:22:16 kls Exp $
+ * $Id: themes.h 1.2 2007/08/05 14:10:22 kls Exp $
  */
 
 #ifndef __THEMES_H
 #define __THEMES_H
 
 #include "i18n.h"
+#include "tools.h"
 #include "osd.h"
 
 class cTheme {
@@ -18,7 +19,7 @@
   enum { MaxThemeColors = 128 };
 private:
   char *name;
-  char *descriptions[I18nNumLanguages];
+  cStringList descriptions;
   char *colorNames[MaxThemeColors];
   tColor colorValues[MaxThemeColors];
   bool FileNameOk(const char *FileName, bool SetName = false);
diff -ruN vdr-1.5.6/timers.c vdr-1.5.7/timers.c
--- vdr-1.5.6/timers.c	2007-06-16 12:41:21.000000000 +0200
+++ vdr-1.5.7/timers.c	2007-08-04 11:23:33.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: timers.c 1.67 2007/06/16 10:41:21 kls Exp $
+ * $Id: timers.c 1.68 2007/08/04 09:23:33 kls Exp $
  */
 
 #include "timers.h"
@@ -218,7 +218,8 @@
   char buffer[DAYBUFFERSIZE];
   char *b = buffer;
   if (WeekDays) {
-     const char *w = "MTWTFSS";
+     // TRANSLATORS: the first character of each weekday, beginning with monday
+     const char *w = trNOOP("MTWTFSS");
      if (!SingleByteChars)
         w = tr(w);
      while (*w) {
diff -ruN vdr-1.5.6/tools.c vdr-1.5.7/tools.c
--- vdr-1.5.6/tools.c	2007-07-21 15:02:45.000000000 +0200
+++ vdr-1.5.7/tools.c	2007-08-05 14:18:15.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.c 1.134 2007/07/21 13:02:45 kls Exp $
+ * $Id: tools.c 1.135 2007/08/05 12:18:15 kls Exp $
  */
 
 #include "tools.h"
@@ -852,6 +852,7 @@
   char buffer[16];
   WeekDay = WeekDay == 0 ? 6 : WeekDay - 1; // we start with Monday==0!
   if (0 <= WeekDay && WeekDay <= 6) {
+     // TRANSLATORS: abbreviated weekdays, beginning with monday (must all be 3 letters!)
      const char *day = tr("MonTueWedThuFriSatSun");
      day += Utf8SymChars(day, WeekDay * 3);
      strn0cpy(buffer, day, min(Utf8SymChars(day, 3) + 1, int(sizeof(buffer))));
@@ -1178,12 +1179,12 @@
 // --- cFileNameList ---------------------------------------------------------
 
 // TODO better GetFileNames(const char *Directory, cStringList *List)?
-cFileNameList::cFileNameList(const char *Directory)
+cFileNameList::cFileNameList(const char *Directory, bool DirsOnly)
 {
-  Load(Directory);
+  Load(Directory, DirsOnly);
 }
 
-bool cFileNameList::Load(const char *Directory)
+bool cFileNameList::Load(const char *Directory, bool DirsOnly)
 {
   Clear();
   if (Directory) {
@@ -1191,8 +1192,16 @@
      struct dirent *e;
      if (d.Ok()) {
         while ((e = d.Next()) != NULL) {
-              if (strcmp(e->d_name, ".") && strcmp(e->d_name, ".."))
+              if (strcmp(e->d_name, ".") && strcmp(e->d_name, "..")) {
+                 if (DirsOnly) {
+                    struct stat ds;
+                    if (stat(e->d_name, &ds) == 0) {
+                       if (S_ISDIR(ds.st_mode))
+                          continue;
+                       }
+                    }
                  Append(strdup(e->d_name));
+                 }
               }
         Sort();
         return true;
diff -ruN vdr-1.5.6/tools.h vdr-1.5.7/tools.h
--- vdr-1.5.6/tools.h	2007-07-21 15:35:45.000000000 +0200
+++ vdr-1.5.7/tools.h	2007-08-05 14:11:52.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.h 1.104 2007/07/21 13:35:45 kls Exp $
+ * $Id: tools.h 1.107 2007/08/05 12:11:52 kls Exp $
  */
 
 #ifndef __TOOLS_H
@@ -28,9 +28,9 @@
 
 extern int SysLogLevel;
 
-#define esyslog(a...) void( (SysLogLevel > 0) ? syslog_with_tid(LOG_ERR,   a) : void() )
-#define isyslog(a...) void( (SysLogLevel > 1) ? syslog_with_tid(LOG_INFO,  a) : void() )
-#define dsyslog(a...) void( (SysLogLevel > 2) ? syslog_with_tid(LOG_DEBUG, a) : void() )
+#define esyslog(a...) void( (SysLogLevel > 0) ? syslog_with_tid(LOG_ERR, a) : void() )
+#define isyslog(a...) void( (SysLogLevel > 1) ? syslog_with_tid(LOG_ERR, a) : void() )
+#define dsyslog(a...) void( (SysLogLevel > 2) ? syslog_with_tid(LOG_ERR, a) : void() )
 
 #define LOG_ERROR         esyslog("ERROR (%s,%d): %m", __FILE__, __LINE__)
 #define LOG_ERROR_STR(s)  esyslog("ERROR: %s: %m", s)
@@ -175,9 +175,9 @@
 char *strreplace(char *s, const char *s1, const char *s2); ///< re-allocates 's' and deletes the original string if necessary!
 inline char *skipspace(const char *s)
 {
-  if (*s > ' ') // most strings don't have any leading space, so handle this case as fast as possible
+  if ((uchar)*s > ' ') // most strings don't have any leading space, so handle this case as fast as possible
      return (char *)s;
-  while (*s && *s <= ' ') // avoiding isspace() here, because it is much slower
+  while (*s && (uchar)*s <= ' ') // avoiding isspace() here, because it is much slower
         s++;
   return (char *)s;
 }
@@ -487,8 +487,8 @@
 
 class cFileNameList : public cStringList {
 public:
-  cFileNameList(const char *Directory = NULL);
-  bool Load(const char *Directory);
+  cFileNameList(const char *Directory = NULL, bool DirsOnly = false);
+  bool Load(const char *Directory, bool DirsOnly = false);
   };
 
 class cHashObject : public cListObject {
diff -ruN vdr-1.5.6/vdr.c vdr-1.5.7/vdr.c
--- vdr-1.5.6/vdr.c	2007-07-22 13:40:01.000000000 +0200
+++ vdr-1.5.7/vdr.c	2007-08-12 13:22:04.000000000 +0200
@@ -16,13 +16,13 @@
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
- * Or, point your browser to http://www.gnu.org/copyleft/gpl.html
+ * Or, point your browser to http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
  *
  * The author can be reached at kls@cadsoft.de
  *
  * The project's page is at http://www.cadsoft.de/vdr
  *
- * $Id: vdr.c 1.294 2007/07/22 11:40:01 kls Exp $
+ * $Id: vdr.c 1.296 2007/08/12 11:22:04 kls Exp $
  */
 
 #include <getopt.h>
@@ -511,6 +511,10 @@
      cCharSetConv::SetSystemCharacterTable(CodeSet);
      }
 
+  // Initialize internationalization:
+
+  I18nInitialize();
+
   // Main program loop variables - need to be here to have them initialized before any EXIT():
 
   cOsdObject *Menu = NULL;
